# Author: Dgass  Blog: https://dangasdiy.top/
# Date: jan 3th, 2025
from machine import Pin, PWM, I2C, ADC
import network
import socket
import math
from time import sleep
#from pico_i2c_lcd import I2cLcd
# onboard pin
global cl, trace, lineco
led = Pin("LED", Pin.OUT)
lineco = 1
# wifi
ssid = 'ORBI92'
password = 'vastcartoon938'
html1 = """<html>
<meta charset="utf-8">
<style>
.web-safe {
font-family: "Courier New", Courier, monospace;
font-size: 1em;
line-height: 0.05em;
}
</style>
<div class='web-safe'><p><h3>%s</h3></p></div>
</html>"""
trace = 0
if trace == 1 :
    wlan = network.WLAN(network.STA_IF)
    wlan.active(True)
    wlan.connect(ssid, password)   
    max_wait = 10    
    while max_wait > 0:
        if wlan.status() < 0 or wlan.status() >= 3:
            break
        max_wait -= 1
        print('waiting for connection...')
        sleep(1)

    if wlan.status() != 3:
        for i in range (1, 100, 1) :
            led.toggle()
            sleep(0.5)
        raise RuntimeError('network connection failed')
    else:
        print('connected')
        status = wlan.ifconfig()
        print( 'ip = ' + status[0] )

    addr = socket.getaddrinfo(status[0], 80)[0][-1]
    s = socket.socket()
    s.bind(addr)
    s.listen(1)    
    print('listening on', addr)
    global cl
    led.value(1)
    cl, addr = s.accept()
    led.value(0)  
def sendmsg(txt) :
    global cl, lineco
    txt = str(lineco) + " " + txt; lineco += 1;    
    print(txt)
    if trace == 0 : return
    response = html1 % txt
    cl.send(response)
#
# servo control
#
def conv_puls (angl):
  return (angl*36+1700)

class servo :  # to control servo
    def __init__(self, servo, max1, rest, max2, loc):
        self.ser = PWM(servo)
        self.ser.freq(50)
        self.loc = loc
        self.speed_rest  = rest
        self.speed_act   = self.speed_rest
        self.speed_max1  = max1
        self.speed_max2  = max2
    
    def speed(self, val):
        self.speed_act =  val
        if self.speed_act < self.speed_max1 : self.speed_act = self.speed_max1
        if self.speed_act > self.speed_max2 : self.speed_act = self.speed_max2
        self.ser.duty_u16(conv_puls(self.speed_act))
        
        buf = self.loc + " servos speed " + str(self.speed_act)  + "   "
        sendmsg(buf)
        
    def stop(self): # put to rest      
        self.ser.duty_u16(conv_puls(self.speed_rest))
      
        buf = self.loc + " servos speed " + str(self.speed_rest) + "   "
        sendmsg(buf)
 
