#
# September 2025 - Gass Daniel - https://dangasdiy.top/
#
# Legged gear driving 
#
from time import sleep
from Functions_lib import servo, sendmsg 
from sys import exit
from machine import Pin
        
# servo left  declaration (pin left servo  , min, rest, max) values in servo angles
servo_left  = servo(16, 70, 90, 110, "left")
# servo right declaration (pin right servo , min, rest, max) values in servo angles
servo_right = servo(17, 70, 90, 110, "right")
# for bluetooth
from machine import UART, ADC
import time
uart = UART(0, 9600)

# init some features
led_int = Pin("LED", Pin.OUT)
co = 1           # display counter
# init servo in rest position
servo_left.stop()
servo_right.stop()
sendmsg("==========================> Ready to start - just wait for bluetooth online <=======================")
try:
    while True:
        val1 = 0   # joystick up/down
        val2 = 0   # joystick left/right
        val3 = '?' # used button
        if uart.any() > 0: # waiting for info from remote control
            data = uart.read()
            # extracting information received
#            print(co, " Data received: ",data) ; co += 1
            ext = data.split() ; exc = len(ext)
            if exc > 1 : val1 = int(ext[0]) ; val2 = int(ext[1])
            if exc == 3 : val3 = ext[2]
            print(co, " Data split ", val1, val2, val3); co += 1

            # servos stops engine
            if val1 == 0 and val2 == 0  : servo_left.stop() ; servo_right.stop()

            # ================   move engin forward or backward
            
            if val3 == '?' and val1 != 0 : servo_left.speed(90 + val1); servo_right.speed(90 - val1)

            # ================   one side move engin forward or backward
            
            elif val3 == b'3' and val2 != 0 : servo_left.speed(90 + val2)
            
            elif val3 == b'4' and val2 != 0 : servo_right.speed(90 + val2)

            # ================   move engin left or right
            
            elif val3 == b'5' and val2 != 0 : servo_left.speed(90 + val2); servo_right.speed(90 + val2)           

            # ================  puts at rest  

            elif val3 == b'9' : # application shutdown
                servo_left.stop()
                servo_right.stop()
                exit()
               
except KeyboardInterrupt:
    print('Keyboard Interrupt')
    servo_left.stop()
    servo_right.stop()   