# console for controlling models or robots
# Daniel Gass october 2024
 
from machine import Pin, UART, ADC
import time
# define bluetooth
uart = UART(0, 9600)
# 
but5  = Pin(5, Pin.IN, Pin.PULL_DOWN)  # GP5 is used to assign pushbuttons to other functions
but22 = Pin(22, Pin.IN, Pin.PULL_DOWN) # GP22 joystick button 
# define GPs affected to the buttons
buttons_left  = (Pin(6, Pin.IN, Pin.PULL_DOWN),Pin(8, Pin.IN, Pin.PULL_DOWN),Pin(10, Pin.IN, Pin.PULL_DOWN),Pin(12, Pin.IN, Pin.PULL_DOWN),Pin(14, Pin.IN, Pin.PULL_DOWN))
buttons_right = (Pin(7, Pin.IN, Pin.PULL_DOWN),Pin(9, Pin.IN, Pin.PULL_DOWN),Pin(11, Pin.IN, Pin.PULL_DOWN),Pin(13, Pin.IN, Pin.PULL_DOWN),Pin(15, Pin.IN, Pin.PULL_DOWN))
# relationship between pushbutton and character to be sent 
prim_cmd_left       = ('1','2','3','4','5')
prim_cmd_right      = ('6','7','8','9','0')
second_cmd_left     = ('A','B','C','D','E') 
second_cmd_right    = ('F','G','H','I','J')
# when a pushbutton is combined with a joystick(up/down), a pushbutton can have two values
prim_cmd_left_joy_d = ('L','M','N','O','P') # combined use with U/D joystick (prim_cmd_left not used)
prim_cmd_left_joy_u = ('Q','R','S','T','U') # combined use with U/D joystick (prim_cmd_right lot used)
#
led  = Pin(26, Pin.OUT) # visual activity control 
poth = ADC(27) # ADC 2  joystick left/right
potv = ADC(28) # ADC 1  joystick up/down
# Programm start
print("program start"); led.high() ; time.sleep(1); led.low() ; # delay for Bluetooth connection
while True:
  seq_to_send = ' '
  buttom_to_send = ' '
  # determine jostick position
  potv_value = potv.read_u16()
  poth_value = poth.read_u16()
  # transform values to scope -100 to +100  
  potvalv = 0
  #if potv_value >    20 and potv_value < 31000: potvalv = (potv_value*100)/31000 - 100
  if potv_value >    20 and potv_value < 27000: potvalv = (potv_value*100)/31000 - 100
  if potv_value > 35000 and potv_value < 66000: potvalv = 100 - (66000 - potv_value)*100/(65535 - 32500)
  potvalh = 0
  if poth_value >     0 and poth_value < 30000: potvalh = (poth_value*100)/32000 - 100
  if poth_value > 35000 and poth_value < 66000: potvalh = 100 - (66000 - poth_value)*100/(65535 - 34000)
#  if poth_value >     0 and poth_value < 32000: potvalh = (poth_value*100)/32000 - 100
#  if poth_value > 34000 and poth_value < 66000: potvalh = 100 - (66000 - poth_value)*100/(65535 - 34000)
  # if button pressed
  if but5.value() : # corresponds to secondary controls, function switch
    # assigns the value to be transmitted according to the pressed pushbutton  
    for i in range(0,5):  # assigns the value to be transmitted according to the selected pushbutton
      if buttons_right[i].value() : buttom_to_send = second_cmd_right[i]; 
      if buttons_left[i].value()  : buttom_to_send = second_cmd_left[i]; 
  else: # corresponds to primary controls, function switch up position
    for i in range(0,5):  # assigns the value to be transmitted according to the selected pushbutton
      if buttons_right[i].value() : buttom_to_send = prim_cmd_right[i]; 
      if buttons_left[i].value()  : buttom_to_send = prim_cmd_left[i];
  # infos to send
  if potvalv > 0   and potvalv < 20 : potvalv =  20
  if potvalv > -20 and potvalv < 00 : potvalv = -20
  if potvalh > 0   and potvalh < 20 : potvalv =  20
  if potvalh > -20 and potvalh < 00 : potvalv = -20  
  seq_to_send =  str(int(potvalv)) + " " + str(int(potvalh)) + " " + buttom_to_send
  print(seq_to_send)
  #
  # send values using bluetooth
  #
  uart.write(seq_to_send + '\n')
  # extraction sur slave (here to test)
  ext = seq_to_send.split()
  exc = len(ext)
  val1 = int(ext[0])
  val2 = int(ext[1])
  val3 = " "
  if exc == 3 : val3 = ext[2]
  print( "test ", val1, val2, val3)
  #
  time.sleep(0.2);